/*  
    =========================================================================

    targe2: a program for "T"riangulation of "AR"bitrary "GE"ometries in "2"D

    =========================================================================

                      Copyright: 1993, 1994 Petr Krysl 

       Czech Technical University in Prague, Faculty of Civil Engineering,
           Dept. Structural Mechanics, 166 29 Prague, Czech Republic,
                          e-mail: pk@aix.fsv.cvut.cz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    =========================================================================
*/

#ifndef CELLS_H
#define CELLS_H

#include "ttypes.h"
#include "targe2.h"
#include "tops.h"
#include "log.h"

void construct_front(void);
void destruct_front(void);
void construct_cells(C_REFS_LIST ext_loop);
void destruct_cells(void);
CELL_ID get_which_cell( float at_x, float at_y );
void setup_cells( float xmin, float ymin, float xmax, float ymax );
void hyperarray_setup(void);
void dummy_cells(void);
void rearrange_cells( float old_cell_size, float new_cell_size );
void remap_to_new_cells(void);
void destroy_free_cells_list(void);
CELL_ID get_which_cell( float at_x, float at_y );
void remap_to_new_cells(void);
void scan_loop_extent(C_REFS_LIST ext_loop,
		      float *xmin, float *ymin, float *xmax, float *ymax);
int init_cells(void);

#define CIX    1 
#define RIX    2 
#define LIX    3 
#define UPIX   4 
#define LOIX   5
#define LUPIX  6 
#define RLOIX  7 
#define RUPIX  8 
#define LLOIX  9

#endif
