/*  
    =========================================================================

    targe2: a program for "T"riangulation of "AR"bitrary "GE"ometries in "2"D

    =========================================================================

                      Copyright: 1993, 1994 Petr Krysl 

       Czech Technical University in Prague, Faculty of Civil Engineering,
           Dept. Structural Mechanics, 166 29 Prague, Czech Republic,
                          e-mail: pk@aix.fsv.cvut.cz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    =========================================================================
*/

#ifndef EDGES_H
#define EDGES_H

#include "ttypes.h"

void         make_edge_list(void);
long int     total_of_edges(void);
EDGE_REC     *add_edge(struct _VERTEX_REC *v1_p, struct _VERTEX_REC *v2_p,
		   struct _CURVE_REC *par_c_p);
void         add_to_front(EDGE_REC_P e_p, sense s, double edge_length);
void         add_edges_of_curve_to_front(struct _CURVE_REC * c_p);
CURVE_REC    *get_edge_curve_p(EDGE_REC_P e_p);
void         get_edge_vertex_p(EDGE_REC_P e_p,
			       VERTEX_REC_P *v1_p, VERTEX_REC_P *v2_p);
void         add_edges_of_curve_to_front(CURVE_REC *c_p);
LIST         get_iterator_list(CELL_ID cell);
void         set_edge_cell(EDGE_REC_P e_p, CELL_ID cell);
CELL_ID      get_edge_cell(EDGE_REC_P e_p);
void         reject_edge(EDGE_REC_P e_p, sense s, double length);
BOOLEAN      pull_edge_from_front(void);
LIST         get_iterator_list(CELL_ID cell);
BOOLEAN      create_iter_lists(void);
BOOLEAN      destroy_iter_lists(void);
void         init_hash_by_length(float minmsize, float maxmsize);
void         first_front_edge(EDGE_REC_P *epp, sense *s);
void         next_front_edge(EDGE_REC_P *epp, sense *s);
void         remove_edge_from_front(EDGE_REC_P ep, sense sense);
void         draw_edges(void);
void
destroy_edge(EDGE_REC *e_p);

#ifdef X_XFACE
void
print_edge_data(FILE *fp, EObjectP p);
#endif

#ifdef FAST_ACCESS

#ifndef EDGES_PRIVATE_HDR
extern EDGE_LIST vertex_list;
#endif

#define set_edge_cell(ep, cell) ((EDGE_REC_P)(ep))->cell = (CELL_ID)(cell)
#define get_edge_cell(ep) ((CELL_ID)(((EDGE_REC_P)(ep))->cell))
#define get_edge_vertex_p(ep, v1p, v2p) \
                     *((VERTEX_REC **)(v1p)) = ((EDGE_REC_P)(ep))->vertex_1; \
                     *((VERTEX_REC **)(v2p)) = ((EDGE_REC_P)(ep))->vertex_2
#define get_edge_curve_p(ep) (CURVE_REC *)((((EDGE_REC_P)(ep))->parent_curve))

#endif /* FAST_ACCESS */

#endif
