/*  
    =========================================================================

    targe2: a program for "T"riangulation of "AR"bitrary "GE"ometries in "2"D

    =========================================================================

                      Copyright: 1993, 1994 Petr Krysl 

       Czech Technical University in Prague, Faculty of Civil Engineering,
           Dept. Structural Mechanics, 166 29 Prague, Czech Republic,
                          e-mail: pk@aix.fsv.cvut.cz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    =========================================================================
*/

#ifndef MCTLP_H
#define MCTLP_H

#include "ttypes.h"

void  
make_mctlp_list(void);
float 
get_mesh_cdim(float at_x, float at_y);
float 
get_mesh_1st_dir_angle(float at_x, float at_y);
float 
get_mesh_2nd_dir_magn_factor(float at_x, float at_y);
void  
add_const_cdim( float cdim );
void  
add_mctl_point( int id, float x, float y, float cdim,
               float infl_radius );
void 
add_mctl_triangle(float x1, float y1,
                  float x2, float y2, float x3, float y3,
                  float v1, float v2, float v3,
                  float mf1, float mf2, float mf3,
                  float ang1, float ang2, float ang3);
float 
mctl_near_fval( float cradius, float infl_radius );
void 
get_maxmin_mesh_cdim(float xmin, float ymin, float xmax, float ymax,
                     float *minmeshsize, float *maxmeshsize );
void 
set_cdim_extremes(float cdim);
void 
get_cdim_extremes(float *min_cd, float *max_cd);

#endif
