/*  
    =========================================================================

    targe2: a program for "T"riangulation of "AR"bitrary "GE"ometries in "2"D

    =========================================================================

                      Copyright: 1993, 1994 Petr Krysl 

       Czech Technical University in Prague, Faculty of Civil Engineering,
           Dept. Structural Mechanics, 166 29 Prague, Czech Republic,
                          e-mail: pk@aix.fsv.cvut.cz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    =========================================================================
*/

#ifndef MESH_H
#define MESH_H

#include "ttypes.h"
#include "targe2.h"
#include "log.h"

void mesh_region(void);
void overall_startup(void);
void overall_cleanup(void);
void mesh_interior(SUBREG_REC *s_r);

float 
ideal_radius(VERTEX_REC *v1_p, VERTEX_REC *v2_p,
             float length, float ipx, float ipy);

float
ideal_edge_length(float fx, float fy, float lx, float ly,
                  float mdim, float mf, float ang);

void  
ideal_point(VERTEX_REC *v1_p, VERTEX_REC *v2_p,
            float *ipx, float *ipy);

void 
construct_triangle(SUBREG_REC *s_r);

void 
update_front(VERTEX_REC *selvertexp, float selvx, float selvy,
             EDGE_REC **edge1_p, EDGE_REC **edge2_p);

BOOLEAN 
no_intersections(VERTEX_REC *selvertexp, float selvx, float selvy,
                 EDGE_REC *to_ignore, EDGE_REC **isectswith_pp);

BOOLEAN
edges_intersect(float x1, float y1, float x2, float y2,
                float boxlx, float boxly, float boxux, float boxuy,
                float x1prime, float y1prime,
                float x2prime, float y2prime);
void 
smooth_mesh(void);

#endif
