/*  
    =========================================================================

    targe2: a program for "T"riangulation of "AR"bitrary "GE"ometries in "2"D

    =========================================================================

                      Copyright: 1993, 1994 Petr Krysl 

       Czech Technical University in Prague, Faculty of Civil Engineering,
           Dept. Structural Mechanics, 166 29 Prague, Czech Republic,
                          e-mail: pk@aix.fsv.cvut.cz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    =========================================================================
*/

#ifndef SUBREGS_H
#define SUBREGS_H

#include "ttypes.h"
#include "targe2.h"
#include "log.h"

BOOLEAN add_subreg(int srid,
		   int pid, int mid, int sid, float thickness, char *group,
		   C_REFS_LIST ext_loop,
		   C_REFS_LIST_LIST int_loops);
void make_subregs_list(void);
void mesh_subregions(void);
void subregions_bbox(float *minx, float *miny, float *maxx, float *maxy);
void subreg_data(SUBREG_REC *subreg,
		 int *pid, int *mid, int *sid, float *thickness, char **group);
void
set_subregions_bbox(float minx, float miny, float maxx, float maxy);

#endif




