/*  
    =========================================================================

    targe2: a program for "T"riangulation of "AR"bitrary "GE"ometries in "2"D

    =========================================================================

                      Copyright: 1993, 1994 Petr Krysl 

       Czech Technical University in Prague, Faculty of Civil Engineering,
           Dept. Structural Mechanics, 166 29 Prague, Czech Republic,
                          e-mail: pk@aix.fsv.cvut.cz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    =========================================================================
*/

#ifndef TOPS_H
#define TOPS_H

#include "ttypes.h"

void init_targe2(int, char **);
void run_targe2(void);
void cleanup_targe2(void);
void print_usage_and_exit(int, char **);
void alloc_error(char *in_proc);
void get_options(int, char **);
void report_startup(void);
void generate(void);
void init_data_structs(void);
void run_targe2(void);
void output_mesh(void);
void get_timing(char *return_string);
void post_banner(int where_to);

BOOLEAN has_suffix(char *f, char *s);
BOOLEAN file_exists(char *f);

extern OPTS_REC options;

#endif
