/*  
    =========================================================================

    targe2: a program for "T"riangulation of "AR"bitrary "GE"ometries in "2"D

    =========================================================================

                      Copyright: 1993, 1994 Petr Krysl 

       Czech Technical University in Prague, Faculty of Civil Engineering,
           Dept. Structural Mechanics, 166 29 Prague, Czech Republic,
                          e-mail: pk@aix.fsv.cvut.cz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    =========================================================================
*/
 
#ifndef TRIANGLE_H
#define TRIANGLE_H

#include "ttypes.h"

void 
make_triangle_list(void);
long int 
total_of_triangles(void);
long int 
total_of_bad_triangles(void);
BOOLEAN 
add_triangle(EDGE_REC *edge_1, EDGE_REC *edge_2, EDGE_REC *edge_3,
		     SUBREG_REC *subreg);
void
destroy_triangle(TRIANGLE_REC *t);
void 
test_triangle_shape(float x1, float y1,
			 float x2, float y2,
			 float x3, float y3,
			 BOOLEAN *good, int *type);
void 
dump_triangles_in_afro_style(FILE *fp);
void 
dump_triangles_in_mos_style(FILE *fp);
void 
produce_mctlts(FILE *fp);

void 
draw_triangles(void);


#define GOOD   0
#define ACUTE  1
#define OBTUSE 2

#endif
