/*  
    =========================================================================

    targe2: a program for "T"riangulation of "AR"bitrary "GE"ometries in "2"D

    =========================================================================

                      Copyright: 1993, 1994 Petr Krysl 

       Czech Technical University in Prague, Faculty of Civil Engineering,
           Dept. Structural Mechanics, 166 29 Prague, Czech Republic,
                          e-mail: pk@aix.fsv.cvut.cz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    =========================================================================
*/

#ifndef UTILS_H
#define UTILS_H

#include <math.h>
#include <stdlib.h>


#include "listP.h"
#include "alistP.h"

/* add-to-LIST convenience macro */
#define make_and_add_to_tail_val(list, rec_p, rec_dcl, routine, val)    \
           if ((rec_p = (rec_dcl *)make_node(sizeof(rec_dcl))) == NULL) \
              alloc_error(routine);                                     \
           else                                                         \
              add_to_tail_val(list, (NODE)rec_p, val)

/* add-to-ALIST convenience macro */
#define make_and_add_to_atail_val(alist, rec_p, rec_dcl, routine, val)  \
           if ((rec_p = (rec_dcl *)make_node(sizeof(rec_dcl))) == NULL) \
              alloc_error(routine);                                     \
           else                                                         \
              add_to_atail_val(alist, (NODE)rec_p, val)


/* change between list and alist */
#ifdef USE_ALISTS
#define MAKE_LIST              make_alist
#define GET_LIST_NEXT          get_alist_next
#define ADD_TO_TAIL_VAL        add_to_atail_val
#define LIST_LENGTH            alist_length   
#define GET_NODE_VAL_CURRENT   get_anode_val_current
#define GET_NODE_VAL           get_anode_val
#define DELETE_LIST_NODE       delete_alist_node
#else  /* !USE_ALISTS */
#define MAKE_LIST              make_list
#define GET_LIST_NEXT          get_list_next
#define ADD_TO_TAIL_VAL        add_to_tail_val
#define LIST_LENGTH            list_length   
#define GET_NODE_VAL_CURRENT   get_node_val_current
#define GET_NODE_VAL           get_node_val
#define DELETE_LIST_NODE       delete_list_node
#endif /* USE_ALISTS */

#define MAKE_AND_ADD_TO_TAIL_VAL(list, rec_p, rec_dcl, routine, val)     \
           if ((rec_p =  (rec_dcl *)make_node(sizeof(rec_dcl))) == NULL) \
              alloc_error(routine);                                      \
           else                                                          \
              ADD_TO_TAIL_VAL(list, (NODE)rec_p, val)

#ifndef SWAP_POINTS
#define SWAP_POINTS(temp, first, last) \
                     temp    = (first); \
                     (first) = (last); \
                     (last)  = temp
#endif

#define min(a,b) (((a) < (b)) ? (a) : (b))
#define max(a,b) (((a) > (b)) ? (a) : (b))
#define min_of_3(a,b,c) (((a) < (b))? \
                             (((c) < (a))? \
                                 (c): \
                                 (a)): \
                             (((c) < (b))? \
                                 (c): \
                                 (b)) \
                        )
#define max_of_3(a,b,c) (((a) > (b))? \
                             (((c) > (a))? \
                                 (c): \
                                 (a)): \
                             (((c) > (b))? \
                                 (c): \
                                 (b)) \
                        )
#define IS_EVEN(n) ((n)/2*2 == (n))

#define DUPLICATE_STRING(dest, src)                      \
   if (((dest) = (char *)malloc((size_t)(strlen(src)+1))) == NULL) \
      alloc_error("DUPLICATE_STRING");                   \
   strcpy((dest), (src))

void manip_error(char *to_print);

double line_length(float fx, float fy, float lx, float ly);

void
stop_run(void);

#define RAW

#ifdef DEBUG
#define DBG(l) l
#else
#define DBG(l) 
#endif

#include <assert.h>

#endif
