#ifndef __VIEWS_H
#define __VIEWS_H


typedef enum  { hide = 0, shown = 1 } visibility;
typedef float loc_type;


#define CLIP_ON  1
#define CLIP_OFF 0



typedef struct {
	visibility status;	  	//  Hide or Shown
	int x1, x2, y1, y2;   	//  Physical coordinates in screen
	loc_type xlogmin, ylogmin;  	//  Scale in x and y direction
	loc_type xlogmax, ylogmax;
	void *domain;		        //  Original swapped area fo screen
	} viewport, *view;


loc_type round (loc_type num, int pos );
int Preved (int poc, int kon, loc_type logmin, loc_type logmax, loc_type sour );
loc_type Preved_inverzne (int poc, int kon, loc_type logmin, loc_type logmax, int sour);

int initviewsys ();
view createview ( int x1, int x2, int y1, int y2, loc_type xlmin, loc_type ylmin, loc_type xlmax, loc_type ylmax );		// Returns NULL if not enough memory
view openview ( view w );            	// Returns 0 if not enough memory
view updatelogview (view w, loc_type xlmin, loc_type ylmin,
		    loc_type xlmax, loc_type ylmax );
																			// the best way then is to make free(w);
void closeview ( view w );
view setactiveview ( view w );
void zoomview (loc_type, loc_type, loc_type, loc_type);
void plottoview ( loc_type x, loc_type y, int color );
void lineview ( loc_type x1, loc_type y1, loc_type x2, loc_type y2 );
void movetoview ( loc_type x1, loc_type y1 );
void linetoview ( loc_type x1, loc_type y1 );
void frameview ( loc_type x1, loc_type y1, loc_type x2, loc_type y2 );
void circletoview (loc_type x, loc_type y, loc_type r);
void arctoview (loc_type x, loc_type y, loc_type stangle, loc_type endangle, loc_type radius);
void texttoview (loc_type x,loc_type y,char *text);
void drawcross (loc_type x,loc_type y, loc_type length);
void drawcross2 (loc_type x,loc_type y, int lenght );
void Fillpolyview (loc_type,loc_type,loc_type,loc_type,loc_type,loc_type);
void Get_location ( loc_type *x, loc_type *y, char *prompt);

#endif
