#!/bin/ksh

#  The program to run
targe2=targe2

#  Header
total=`/bin/ls t[0-9] t[0-9][0-9] t[0-9][0-9][0-9] | wc -l`
echo "\n         TARGE2 v1.0 (C) 1993,1994 Petr Krysl "
echo "                                                "
echo "         Running $targe2 to test it on $total input files ..."
echo "         Test results in file test.log          "
echo "               Hit <CR> to continue\c           "
read resp

#  Options
flags=$*

#  Processing
echo "\n         Processing file #"
rm -f test.log
i=10
for n in  t[0-9] t[0-9][0-9] t[0-9][0-9][0-9]
do
	if [ $i -gt 9 ] ; then
		i=0
		echo "      "
		echo "         \c"
	fi
        num=`echo $n | sed s/t//g`
        if   [ $num -le 9 ] ; then
                echo "  $num, \c"
        elif [ $num -le 99 ] ; then
                echo " $num, \c"
        else
        	echo "$num, \c"
        fi
	echo "     ====> $n" >>test.log
	$targe2 -v -n -i $n $flags  2>>test.log 1>&2
        if [ `grep rror test.log | wc -l` -ne 0 ] ; then
                echo "Error(s) found.  See test.log for details."
                exit 1
        fi
	i=`echo "$i+1" | bc`
done

echo "\n\n         Done. \c"

num_errors=`grep rror test.log | wc -l`
if [ $num_errors -ne 0 ] ; then
        echo "$num_errors error(s) found.  See test.log for details."
else
        echo "No errors."
fi

