#include "ttypes.h"

#define MIN_X -100.
#define MAX_X +100.
#define MIN_Y -100.
#define MAX_Y +100.

#define STEPX 1.
#define STEPY 1.
#define MAX_POINTS 1000
#define NORMALIZE_BY (2.149e9)

static numb_points = MAX_POINTS;

char *optarg = NULL;

float mctl_func(float at_x, float at_y);

int getopt(int argc, char **argv, char *flags);

#define OPTIONS "p:"

int options(int argc, char **argv)
{
  int ret;
  
  while((ret = getopt(argc, argv, OPTIONS)) != EOF) {
    switch(ret) {
    case '?':
      printf("Usage: %s [-p points]\n", argv[0]);
      exit(1);
      break;
    case 'p':
      numb_points = (int)strtod(optarg, NULL);
      break;
    }
  }
}

int main(int argc, char **argv)
{
  float x, y;
  int i = 0;
  float stepx, stepy;

  options(argc, argv);
  
  for (x = MIN_X, stepx = (MAX_X-MIN_X)/sqrt(numb_points);
       x < MAX_X; x += stepx) 
    for (y = MIN_Y, stepy = (MAX_Y-MIN_Y)/sqrt(numb_points);
	 y < MAX_Y; y += stepy) 
      printf("m-ctl-point %d xy %f %f near %f influence 1.0\n",
	     ++i, x, y, mctl_func(x, y));
}

#include "mctlfunc.c"


int getopt(int argc, char **argv, char *flags)
{
  static int started = NO;
  static char *current_flag;
  int i, j, retval;

  if (!started) {
    current_flag  = flags;
    started       = YES;
  }
  for (i = 1; i < argc; i++) {
    if ((int)argv[i][0] == (int)'-') {
      j = 0;
      while (argv[i][j] != '\0') {
	if ((int)argv[i][j] == (int)(*current_flag)) {
	  retval = (int)(*current_flag);
	  if ((int)(*(current_flag+1)) == (int)':') {
	    optarg = argv[i+1];
	    current_flag++;
	  }
	  current_flag++;
	  return retval;
	}
	j++;
      }
    }
  }

  if (*(++current_flag) == '\0') {
    started = NO;
    return EOF;
  } else 
    return 0;
}
