/*  
    =========================================================================

    targe2: a program for "T"riangulation of "AR"bitrary "GE"ometries in "2"D

    =========================================================================

                      Copyright: 1993, 1994 Petr Krysl 

       Czech Technical University in Prague, Faculty of Civil Engineering,
           Dept. Structural Mechanics, 166 29 Prague, Czech Republic,
                          e-mail: pk@aix.fsv.cvut.cz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    =========================================================================
*/
 
#include "targe2cf.h"
#include "ttypes.h"

#include <stdio.h>
#ifdef UNIX
#include <unistd.h>
#endif
#include <string.h>

#include "targe2.h"
#include "tops.h"
#include "log.h"

static int opened = NO;
static FILE *log_FILE_p = NULL;
static void open_log_file(void);

 /* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

static void open_log_file(void)
{
  if (!opened ) {
    if (options.log_file_name != NULL)	{
      if ((log_FILE_p = fopen(options.log_file_name, "a+")) == NULL) {
	fprintf(stderr, "\nFailed to open log file \"%s\" for append",
		options.log_file_name);
	exit(1);
      }
    } else {
      log_FILE_p = stderr;
    }
    opened = YES;
  }
}
 /* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
 /* log_to_file  */

void log_to_file(char *proc, char *to_print)
{
  if (!opened )
    open_log_file();
  if (proc != NULL)
    fprintf(log_FILE_p, "Proc: %s, %s\n", proc, to_print);
  else
    fprintf(log_FILE_p, " %s\n", to_print);
}
 /* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
 /* close_log_file  */

void close_log_file()
{
  if (opened) {
    if (log_FILE_p != NULL && log_FILE_p != stderr)	{
      fprintf(log_FILE_p, "\nClosing log file");
      fclose(log_FILE_p);
    }
    opened = NO;
  }
}

