#include "targe2cf.h"
#include "ttypes.h"

#ifdef MCTL_BY_FUNC

#define MIN_X -100.
#define MAX_X +100.
#define MIN_Y -100.
#define MAX_Y +100.

#ifndef USE_FUNC_NUMBER
#define USE_FUNC_NUMBER 19
#endif

int mctl_func_start(void)
{
  return USE_FUNC_NUMBER;
}

#if (USE_FUNC_NUMBER == 0)
float mctl_func(float at_x, float at_y)
{
  float tmp, ksi, eta;

  ksi = at_x;
  eta = at_y;
  tmp = 0.5*fabs((eta+ksi)*sin(0.02*eta))+1;
  return tmp;
} 
#endif

#if (USE_FUNC_NUMBER == 1)
float mctl_func(float at_x, float at_y)
{
  float tmp, ksi, eta;

  ksi = (at_x-0.5*(MAX_X+MIN_X))/(MAX_X-MIN_X);
  eta = (at_y-0.5*(MAX_Y+MIN_Y))/(MAX_Y-MIN_Y);
  tmp = sqrt(1000*eta*eta*sqrt(10*fabs(sin(sqrt(ksi*ksi)))));
  tmp = fabs(tmp) + 5;
  return tmp;
} 
#endif

#if (USE_FUNC_NUMBER == 2)
float mctl_func(float at_x, float at_y)
{
  float tmp, ksi, eta;

  ksi = (at_x-0.5*(MAX_X+MIN_X))/(MAX_X-MIN_X);
  eta = (at_y-0.5*(MAX_Y+MIN_Y))/(MAX_Y-MIN_Y);
  tmp = fabs(sin(6*eta)*sin(6*ksi));
  tmp = 30*sqrt(tmp*tmp*tmp) + 0.5;
  return tmp;
} 
#endif

#if (USE_FUNC_NUMBER == 3)	/* ** */
float mctl_func(float at_x, float at_y)
{
  float tmp, ksi, eta, r;

  ksi = (at_x-0.5*(MAX_X+MIN_X))/(MAX_X-MIN_X);
  eta = (at_y-0.5*(MAX_Y+MIN_Y))/(MAX_Y-MIN_Y);
  r   = sqrt(ksi*ksi+eta*eta)+0.01;
  tmp = fabs(sin((eta*(-eta)*(-ksi))));
  tmp = 20*sqrt(fabs(ksi-eta)*tmp) + 0.5;
  return tmp/r/r;
} 
#endif

#if (USE_FUNC_NUMBER == 4)	/* *** Fine circumference, gross center */
float mctl_func(float at_x, float at_y)
{
  float tmp, ksi, eta, r;

  ksi = (at_x-0.5*(MAX_X+MIN_X))/(MAX_X-MIN_X);
  eta = (at_y-0.5*(MAX_Y+MIN_Y))/(MAX_Y-MIN_Y);
  r   = (ksi*ksi+eta*eta)+0.5;
  return 1/r/r/r/r/r;
} 
#endif

#if (USE_FUNC_NUMBER == 5)	/* *** Concentric circles of small size */
float mctl_func(float at_x, float at_y)
{
  float tmp, ksi, eta, r;

  ksi = (at_x-0.5*(MAX_X+MIN_X))/(MAX_X-MIN_X);
  eta = (at_y-0.5*(MAX_Y+MIN_Y))/(MAX_Y-MIN_Y);
  r   = (ksi*ksi+eta*eta);
  return 8*(fabs(sin(24*r))+0.1);
} 
#endif

#if (USE_FUNC_NUMBER == 6)	/* *** */
float mctl_func(float at_x, float at_y)
{
  float tmp, ksi, eta, r;

  ksi = (at_x-0.5*(MAX_X+MIN_X))/(MAX_X-MIN_X);
  eta = (at_y-0.5*(MAX_Y+MIN_Y))/(MAX_Y-MIN_Y);
  r   = (ksi*ksi+eta*eta);
  return ((at_x*(at_x+1))/100 + 5);
} 
#endif

#if (USE_FUNC_NUMBER == 18)
float mctl_func(float at_x, float at_y)
{
  float tmp, ksi, eta;

  ksi = (at_x-0.5*(MAX_X+MIN_X))/(MAX_X-MIN_X);
  eta = (at_y-0.5*(MAX_Y+MIN_Y))/(MAX_Y-MIN_Y);
  tmp = 30*fabs(sin(6*eta)*sin(6*ksi)) + 0.5;
  return tmp;
} 
#endif

#if (USE_FUNC_NUMBER == 19)
float mctl_func(float at_x, float at_y)
{
  float tmp, r1, r2, ksi, eta;

  ksi = (at_x-0.5*(MAX_X+MIN_X))/(MAX_X-MIN_X);
  eta = (at_y-0.5*(MAX_Y+MIN_Y))/(MAX_Y-MIN_Y);
  r1 = (ksi == 0? 1: 10*sin(3*ksi)/ksi);
  r2 = (eta == 0? 1: 10*sin(3*eta)/eta); 
  tmp = 3*fabs(0.3 - 10 * (eta + ksi) * r1 * r1 * r2 * r2) + 0.5;
  return tmp;
} 
#endif

#endif /* MCTL_BY_FUNC */


