/*#include "triangle.h"*/
#include "scr.h"
#include "views.h"
#include "status.h"
#include <string.h>
#include <stdlib.h>
#include <math.h>

#define BUFF_LEN 11
extern int gr_maxx,gr_maxy;
extern int char_height,char_width;
extern int status_length;
extern int status_height;
extern loc_type _xmin,_xmax,_ymin,_ymax;
static int currPos,printPos;
static int x_left_corner,y_left_corner,length;
static char* editString;
int keycount;
char keytable[11];


void editLine (char* buf, int b, int i, int y, int x, int maxchar);
void Menu_status1 ();


void Clear_status_area ()
{
	int bottom;
	setactiveview(status_view);
	setfillstyle (SOLID_FILL,STATUS_BGR);
	bar (1,1,gr_maxx-LOGO_WIDTH-1,status_height-1);
	setactiveview(main_view);
}



void Clear_status (int line)
{
	int bottom;
	setactiveview(status_view);
	setfillstyle (SOLID_FILL,STATUS_BGR);
	bottom=status_height-LINESKIP-(line-1)*(LINESKIP+char_height);
	bar (1,bottom,gr_maxx-LOGO_WIDTH-1,bottom-char_height);
	setactiveview(main_view);
}

int Print_Status (int hard_end)
{
	long int triangles;
	char b[15],msg[40];

	triangles=total_of_triangles();
	ltoa(triangles,b,10);
	strcpy(msg,TR_MSG);
	strcat(msg,b);

	Print_status (2,msg);
	/* check for hot-key */
	return Check_status (hard_end);
}


int Check_status (int hard_end)
{
	char key;
	loc_type x1,x2,y1,y2;
	char stline[80];
	double xx;


	if (!kbhit()) return ;


	/* interaction with user */
	key=tolower(getch ());
	if (key == tolower(keytable[0]))
	{
		/* zoom all */
		setactiveview (main_view);
		updatelogview (main_view, _xmin, _ymin,
		    _xmax, _ymax);
		openview(main_view);
		setactiveview (main_view);
		clearviewport();
		setcolor(FRAME);
		frameview (main_view->xlogmin,main_view->ylogmin,main_view->xlogmax,main_view->ylogmax);
		setcolor(DRAW_AREA_INK);
		draw_edges ();
		setactiveview(main_view);
	} else if (key == tolower(keytable[1]))
	{
		/* zoom */
		/* ask for coordinates */
		Clear_status(2);
		sprintf(stline," Rozsah oblasti: x od %5.1f do %5.1f ; y od %5.1f do %5.1f",_xmin,_xmax,_ymin,_ymax);
		Print_status(2,stline);

		Input_status2(&x1,&y1,ZOOM_MSG1,ZOOM_MSG2,1);
		Input_status2(&x2,&y2,ZOOM_MSG3,ZOOM_MSG2,1);
		Clear_status(1);
		setactiveview(status_view);
		Menu_status1 ();
		updatelogview (main_view, x1, y1,
		    x2, y2 );
		openview(main_view);
		setactiveview(main_view);
		clearviewport();
		setcolor(FRAME);
		frameview (main_view->xlogmin,main_view->ylogmin,main_view->xlogmax,main_view->ylogmax);
		setcolor(DRAW_AREA_INK);
		draw_edges ();
		Clear_status(2);
		setactiveview(main_view);
	} else if (key == tolower(keytable[2]))
	{
		if (hard_end)
		{
			/* continue */
			closegraph();
			exit(0);
		} else return 1;
	}
	return 0;
}


void Print_status (int line, char * str)
{
	int bottom;
	Clear_status (line);
	setactiveview(status_view);
	bottom=status_height-LINESKIP-char_height-(line-1)*(LINESKIP+char_height);
	setcolor(STATUS_INK);
	outtextxy(3,bottom,str);
	setactiveview(main_view);
}

void Input_status (int line,char* msg,float def,float* retval)
{
	int i,currx;
	char msg1[80];
	char buf[BUFF_LEN];

	strcpy(msg1,msg);
	strcat(msg1," <");
	strcat(msg1,gcvt(def,6,buf));
	strcat(msg1,"> :");
	Print_status(line,msg1);
	currx=3+textwidth(msg1);
	for (i = 0; i<=BUFF_LEN-2; i++)	buf[i]=' ';
	buf[BUFF_LEN-1]='\n';
	setactiveview(status_view);
	editLine (buf,STATUS_BGR,STATUS_INK,
		status_height-LINESKIP-char_height-(line-1)*(LINESKIP+char_height),currx,
		BUFF_LEN-2);
	setactiveview(main_view);

}

void Input_status2 (loc_type *x1, loc_type *y1,char *msg1, char* msg2,int line)
{
	char *ptr;
	char buf[BUFF_LEN];
	double xx;
	int bottom,len,i;


	Clear_status (1);
	bottom=status_height-LINESKIP-char_height-(line-1)*(LINESKIP+char_height);
	setactiveview(status_view);
	setcolor(STATUS_INK);
	outtextxy (3,bottom,msg1);
	len=strlen(msg1);
	len=3+len*char_width;
	for (i = 0; i<=BUFF_LEN-2; i++)	buf[i]=' ';
	buf[BUFF_LEN-1]='\n';
	setactiveview(status_view);
	do
	{
		editLine (buf, INBOX_BGR, INBOX_INK, bottom, len, 10);
		xx = strtod(buf, &ptr);
	} while(!(ptr != buf && errno == 0 && fabs(xx) < HUGE_VAL));
	*x1=(loc_type)xx;
	len=len+BUFF_LEN*char_width;
	setcolor(STATUS_INK);
	outtextxy(len,bottom,msg2);
	for (i = 0; i<=BUFF_LEN-2; i++)	buf[i]=' ';
	buf[BUFF_LEN-1]='\n';
	len = len+strlen(msg2)*char_width;
	do
	{
		editLine (buf, INBOX_BGR, INBOX_INK, bottom, len, 10);
		xx = strtod(buf, &ptr);
	} while(!(ptr != buf && errno == 0 && fabs(xx) < HUGE_VAL));
	*y1=(loc_type)xx;
	setactiveview(main_view);
}


void Status_loop ()
{
	while (!kbhit()) /* do nothing */ ;
	getch();
}

void Status_loop_end ()
{
	while (!kbhit()) /* do nothing */ ;
	getch();
	while (!kbhit()) /* do nothing */ ;
	getch();
	exit(0);
}

PrintMenuLine (char *str)
{
	char key,*p;
	char *str1;
	char b[]="a";
	int i,j,bottom,line=1;
	char buf[BUFF_LEN];

	str1=strdup(str);
	bottom=status_height-LINESKIP-char_height-(line-1)*(LINESKIP+char_height);
	Clear_status(line);
	setactiveview(status_view);
	moveto (3,bottom);
	setcolor(WHITE);
/*	outtextxy(3,bottom,"AHOJ"); */
Again:
	;
	setactiveview(status_view);
	moveto (3,bottom);
	str1=strdup(str);

	i=0;keycount=0;
	while ( !(p=strchr(str1+i,'~')) == NULL)
	{
		j=p-str1;
		str1[j]='\0';
		setcolor(STATUS_INK);
		outtext(str1+i);
		setcolor(STATUS_INK_HILITE);
		b[0]=p[1];
		keytable[keycount++]=p[1];
		outtext(b);
		setcolor(STATUS_INK);
		i= j+2;
	}
	outtext(str1+i);
	free (str1);
}

void Menu_status1 ()
{
/* starts interaction with user */
	PrintMenuLine (MLINE1);
}

void cursorShow (int b, int i)
{
	char p[2];
	p[0]=FULL_CHAR;
	p[1]='\0';
	setcolor (b);
	outtextxy ((currPos-printPos)*length+x_left_corner,y_left_corner,p);
	p[0]=(editString)[currPos];
	setcolor (i);
	outtextxy ((currPos-printPos)*length+x_left_corner,y_left_corner,p);
}

void editLine (char* buf, int b, int i, int y, int x, int maxchar)
{
	char key;

	length=textwidth("A");
	editString=buf;
	y_left_corner =y;
	x_left_corner = x;
	printPos=0;
	currPos=0;
	cursorShow (STATUS_BGR,STATUS_INK);
	do {
	switch (key=getch())
	{
		case ENTER:
			break;
		case BACKSPACE:
			editString[currPos]=' ';
			cursorShow(STATUS_BGR,STATUS_INK);
			if (currPos>0) currPos-- ;
			cursorShow(STATUS_INK,STATUS_BGR);
			break;
		default:
			if(isascii(key)) {
				if (currPos <= maxchar) {
					editString[currPos]=key;
					cursorShow(STATUS_BGR,STATUS_INK);
					currPos++;
					cursorShow(STATUS_INK,STATUS_BGR);
				}
			}
	}
	} while (!(key == ENTER));
 return;
}


void Exit_loop ()
{
	char key;

	/* check for hot-key */

	/* interaction with user */
Again: ;
	key=tolower(getch ());
	if (key == ESCAPE)
	{
		/* exit */
		closegraph();
		exit(0);
	} else if (key == ENTER)
	{
		return;
	}
	goto Again;
}
