/*  
    =========================================================================

    targe2: a program for "T"riangulation of "AR"bitrary "GE"ometries in "2"D

    =========================================================================

                      Copyright: 1993, 1994 Petr Krysl 

       Czech Technical University in Prague, Faculty of Civil Engineering,
           Dept. Structural Mechanics, 166 29 Prague, Czech Republic,
                          e-mail: pk@aix.fsv.cvut.cz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    =========================================================================
*/

#include "targe2cf.h"
#include "ttypes.h"
#include <math.h> 
#include "tops.h"

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/stat.h>

#include "utils.h"

#ifdef X_XFACE
#include "xiface.h"
#endif

#ifdef DOS_GXFACE

#include "views.h"
#include "scr.h"
#include "status.h"

#endif
#ifdef MSDOS
#include <io.h>
/*#include <alloc.h>*/
#endif

 /* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

void manip_error(char *to_print)
{
#ifdef DOS_GXFACE
  if (options.DOS_gxface) {
/* RAW: fatal error */
  } else {
    fprintf(stderr, "Error --> %s\n", to_print);
  }
#else  
  fprintf(stderr, "Error --> %s\n", to_print);
#   ifdef X_XFACE
  if (options.X_xface) 
    xiface_loop(YES, "Error conditions detected.");
#   endif
  exit(EXIT_RETURN_FAILURE);
#endif  
}

 /* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

double 
line_length(float fx, float fy, float lx, float ly)
{
  double temp1, temp2;
  temp1 = (double)(fx - lx);  temp1 *= temp1;
  temp2 = (double)(fy - ly);  temp2 *= temp2;
  return sqrt(temp1 + temp2); 
}

void
stop_run(void)
{
  exit(EXIT_RETURN_SUCCESS);
}
