/*
	Simple Graphics Interface under DOS version 2.0
	Programmed by Borek Patzak

	January, 1993
*/

#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <alloc.h>
#include <string.h>
#include <conio.h>
#include <math.h>
#include "views.h"



// verze 2.0
//
// kladna osa x z leva do prava
// kladna osa y ze zhora dolu
//
//


static view zoom_view ;
int gr_maxx, gr_maxy;
int xasp,yasp;



loc_type round (loc_type num, int pos)
{
	num = ceil (num * pow10 (pos))/pow10(pos);
	return num;
}


int Preved (int poc, int kon, loc_type logmin, loc_type logmax, loc_type sour )
{
	loc_type rate;
	rate = ( kon - poc ) * (( sour - logmin) / ( loc_type ) (logmax-logmin));
	return ( int ) rate;
}



loc_type Preved_inverzne (int poc, int kon, loc_type logmin, loc_type logmax, int sour)
{
	return (((loc_type)(sour - poc)/(loc_type)(kon - poc))*(logmax-logmin)+logmin);
}


int Zmensi (int poc, int kon, loc_type logmin, loc_type logmax, loc_type r )
{
	loc_type rate;
	rate = ( kon - poc ) * ( r / ( loc_type ) (logmax-logmin));
	return ( int ) rate;
}


// Pointer to active view structure

view actual_view = NULL;


int initviewsys ()
{

	 /* request auto detection */
	 int gdriver = DETECT, gmode, errorcode;

	 /* initialize graphics mode */
	 initgraph(&gdriver, &gmode, "");

	 /* read result of initialization */
	 errorcode = graphresult();

	 if ( errorcode != grOk ) {         /* an error occurred */
			printf ( "Graphics error : %s\n", grapherrormsg ( errorcode ));
			printf ( "Press any key to halt : " );
			getch ();
			exit ( 1 );                     /* return with error code */
	 }
	 gr_maxx=getmaxx();
	 gr_maxy=getmaxy();
	 return 1;
}

view createview (int x1, int y1, int x2, int y2, loc_type xlmin, loc_type ylmin,
		 loc_type xlmax, loc_type ylmax )
{
	 view w;
	 loc_type dlx,dly;

	 /* allocate memory for string */
	 if (( w = ( view ) malloc ( sizeof ( viewport ))) == NULL )
	 {
			printf ( "Not enough memory to allocate buffer\n" );
			exit ( 1 );         /* terminate program if out of memory */
	 }

	 (*w).x1 = x1;
	 (*w).x2 = x2;
	 (*w).y1 = y1;
	 (*w).y2 = y2;
	 dlx=xlmax-xlmin;
	 dly=ylmax-ylmin;
/*	 if(dlx > dly*gr_maxx/gr_maxy)
		ylmax=ylmin+dlx*gr_maxy/gr_maxx;
	 else   xlmax=xlmin+dly*gr_maxx/gr_maxy;
*/
	 if(dlx/gr_maxx > dly/gr_maxy)
		ylmax=ylmin+dlx/gr_maxx*gr_maxy;
	 else   xlmax=xlmin+dly/gr_maxy*gr_maxx;
	 ylmax=ylmax*yasp/xasp;

	 (*w).xlogmin = xlmin;
	 (*w).ylogmin = ylmin;
	 (*w).xlogmax = xlmax;
	 (*w).ylogmax = ylmax;
	 (*w).status = hide;


	 return w;
}


view openview (view w)
{

	struct viewporttype vp;
	unsigned int size;
	void *arrow;

/*	getviewsettings ( &vp );  // Store the old viewport
		setviewport ( 0, 0, getmaxx (), getmaxy (), CLIP_ON );

		size = imagesize ((*w).x1, (*w).y1, (*w).x2, (*w).y2 );
		 if (( arrow = malloc ( size )) == NULL )
		 {
					printf ( "Not enough memory to allocate buffer\n" );
					return 0;
		 }

	// grab the image
	getimage ((*w).x1, (*w).y1, (*w).x2, (*w).y2, arrow );
	(*w).domain = arrow;
	setviewport ( vp.left, vp.top, vp.right, vp.bottom, vp.clip);
*/
		// Restore the old viewport
	(*w).status = shown;
	return w;
}

void closeview ( view w )
{
	struct viewporttype vp;

	getviewsettings ( &vp );	// Store the old viewport
/*	setviewport ( 0, 0, getmaxx (), getmaxy (), CLIP_ON );
	// Recover the former screen area
	putimage ((*w).x1, (*w).y1, (*w).domain, COPY_PUT );
	// Free the memory
	free ((*w).domain );
	// Restore the old viewport
	setviewport (vp.left, vp.top, vp.right, vp.bottom, vp.clip );
*/
	free ( w );

}


view setactiveview ( view w )
{
	if (((*w).status) == shown)  actual_view = w;
	else printf ("Active view must be open\n");
	setviewport ((*w).x1, (*w).y1, (*w).x2, (*w).y2, CLIP_ON);
//	set_horiz_rate ((*w).x1,(*w).x2);
//	set_vert_rate  ((*w).y1,(*w).y2);
	return w;
}



view updatelogview (view w, loc_type xlmin, loc_type ylmin,
		    loc_type xlmax, loc_type ylmax )
{
	 loc_type dlx, dly;

	 dlx=xlmax-xlmin;
	 dly=ylmax-ylmin;
/*	 if(dlx > dly*gr_maxx/gr_maxy)
		ylmax=ylmin+dlx*gr_maxy/gr_maxx;
	 else   xlmax=xlmin+dly*gr_maxx/gr_maxy;
*/
	 if(dlx/gr_maxx > dly/gr_maxy)
		ylmax=ylmin+dlx/gr_maxx*gr_maxy;
	 else   xlmax=xlmin+dly/gr_maxy*gr_maxx;
	 ylmax=ylmax*yasp/xasp;

	 (*w).xlogmin = xlmin;
	 (*w).ylogmin = ylmin;
	 (*w).xlogmax = xlmax;
	 (*w).ylogmax = ylmax;
	 (*w).status = hide;


	 return w;
}


void zoomview (loc_type xa, loc_type ya, loc_type xb, loc_type yb)
{
	(*zoom_view).x1 = (*actual_view).x1;
	(*zoom_view).x2 = (*actual_view).x2;
	(*zoom_view).y1 = (*actual_view).y1;
	(*zoom_view).y2 = (*actual_view).y2;
	updatelogview (zoom_view,xa,ya,xb,yb);
	openview(zoom_view);
	setactiveview (zoom_view);
}

void plottoview (loc_type x, loc_type y, int color)
{
	y = ((*actual_view).ylogmax - y) + (*actual_view).ylogmin;
	if (actual_view == NULL)
	{
		printf ("Not active view\n");
		return;
	}
	putpixel (Preved((*actual_view).x1, (*actual_view).x2, (*actual_view).xlogmin, (*actual_view).xlogmax, x),
						Preved((*actual_view).y1, (*actual_view).y2, (*actual_view).ylogmin, (*actual_view).ylogmax, y),
						color );
}


void lineview (loc_type x1, loc_type y1, loc_type x2, loc_type y2)
{
	y1 = ((*actual_view).ylogmax - y1) + (*actual_view).ylogmin;
	y2 = ((*actual_view).ylogmax - y2) + (*actual_view).ylogmin;
	if (actual_view == NULL)
	{
		printf ("Not active view\n");
		return;
	}
	line (Preved((*actual_view).x1, (*actual_view).x2, (*actual_view).xlogmin, (*actual_view).xlogmax, x1),
				Preved((*actual_view).y1, (*actual_view).y2, (*actual_view).ylogmin, (*actual_view).ylogmax, y1),
				Preved((*actual_view).x1, (*actual_view).x2, (*actual_view).xlogmin, (*actual_view).xlogmax, x2),
				Preved((*actual_view).y1, (*actual_view).y2, (*actual_view).ylogmin, (*actual_view).ylogmax, y2));
}

void movetoview (loc_type x1, loc_type y1)
{
	y1 = ((*actual_view).ylogmax - y1) + (*actual_view).ylogmin;
		if (actual_view == NULL)
		{
			printf ("Not active view\n");
			return;
		}
		moveto (Preved((*actual_view).x1, (*actual_view).x2, (*actual_view).xlogmin, (*actual_view).xlogmax, x1),
				Preved((*actual_view).y1, (*actual_view).y2, (*actual_view).ylogmin, (*actual_view).ylogmax, y1));

}


void linetoview (loc_type x1, loc_type y1)
{
	y1 = ((*actual_view).ylogmax - y1) + (*actual_view).ylogmin;
	if (actual_view == NULL)
	{
		printf ("Not active view\n");
		return;
	}
	lineto (Preved((*actual_view).x1, (*actual_view).x2, (*actual_view).xlogmin, (*actual_view).xlogmax, x1),
					Preved((*actual_view).y1, (*actual_view).y2, (*actual_view).ylogmin, (*actual_view).ylogmax, y1));
}



void frameview (loc_type x1, loc_type y1, loc_type x2, loc_type y2)
{
//	y1 = ((*actual_view).ylogmax - y1) + (*actual_view).ylogmin;
//	y2 = ((*actual_view).ylogmax - y2) + (*actual_view).ylogmin;
	if (actual_view == NULL )
	{
		printf ("Not active view\n");
		return;
	}
	// move CP at location (x1,y1)
	movetoview (x1,y1);
	linetoview (x1,y2);
	linetoview (x2,y2);
	linetoview (x2,y1);
	linetoview (x1,y1);
}


void circletoview (loc_type X, loc_type Y, loc_type Radius)
{
	float fi;

	if (actual_view == NULL )
	{
		printf ("Not active view\n");
		return;
	}

	movetoview (X+Radius,Y);
	for (fi=0.314;fi<=6.29;fi+=0.314) linetoview (X+Radius*cos(fi),
																								 Y+Radius*sin(fi));
}



void arctoview (loc_type X, loc_type Y, loc_type StartAngle, loc_type EndAngle, loc_type Radius)
{
	float fi,delta;

	if (actual_view == NULL ) {
		printf ("Not active view\n");
		return; }

	 delta=(EndAngle-StartAngle)/12.;
	 movetoview (X+Radius*cos(StartAngle),
		 Y+Radius*sin(StartAngle));
	 for (fi=StartAngle;fi<=EndAngle+0.01;fi+=delta) linetoview (X+Radius*cos(fi),
																															Y+Radius*sin(fi));

}

void texttoview (loc_type x,loc_type y,char *text) {

	y = ((*actual_view).ylogmax - y) + (*actual_view).ylogmin;
	if (actual_view == NULL ) {
		printf ("Not active view\n");
		return; }
	outtextxy (Preved((*actual_view).x1, (*actual_view).x2, (*actual_view).xlogmin, (*actual_view).xlogmax, x),
						 Preved((*actual_view).y1, (*actual_view).y2, (*actual_view).ylogmin, (*actual_view).ylogmax, y),
						 text );
}


void drawcross2 (loc_type x, loc_type y, int lenght ) {
//
// draw a cross at position x,y with lenght lenght of real screen points
//
	movetoview (x,y);
  moverel (-lenght,0);
  linerel (2*lenght,0);
  moverel (-lenght,-lenght);
  linerel (0,2*lenght);
}


//
// some enhancment of module wiews.cpp in order to allow
// efficient post-processing in MeshCad (c) 1992
//
void Fillpolyview (loc_type x1, loc_type y1, loc_type x2, loc_type y2,
					loc_type x3, loc_type y3) {

	int poly [6];
	y1 = ((*actual_view).ylogmax - y1) + (*actual_view).ylogmin;
	y2 = ((*actual_view).ylogmax - y2) + (*actual_view).ylogmin;
	y3 = ((*actual_view).ylogmax - y3) + (*actual_view).ylogmin;

	if (actual_view == NULL) {
	printf ("Not active view\n");
	return; }
	poly[0]=Preved((*actual_view).x1, (*actual_view).x2, (*actual_view).xlogmin, (*actual_view).xlogmax, x1);
	poly[2]=Preved((*actual_view).x1, (*actual_view).x2, (*actual_view).xlogmin, (*actual_view).xlogmax, x2);
	poly[4]=Preved((*actual_view).x1, (*actual_view).x2, (*actual_view).xlogmin, (*actual_view).xlogmax, x3);
	poly[1]=Preved((*actual_view).y1, (*actual_view).y2, (*actual_view).ylogmin, (*actual_view).ylogmax, y1);
	poly[3]=Preved((*actual_view).y1, (*actual_view).y2, (*actual_view).ylogmin, (*actual_view).ylogmax, y2);
	poly[5]=Preved((*actual_view).y1, (*actual_view).y2, (*actual_view).ylogmin, (*actual_view).ylogmax, y3);
	fillpoly (3,poly);
}


void Get_location ( loc_type *x, loc_type *y, char *prompt)
{
/*char temp [81];

clear_status();
gotoxy (1,Status_line);
printf ("%s",prompt);
gets (temp);
sscanf (temp ,"%f %f",x,y);*/
}

